Ginkgo: gko::matrix::SparsityCsr< ValueType, IndexType > Class Template Reference

| Ginkgo Generated from branch based on main. Ginkgo version 1.11.0 A numerical linear algebra library targeting many-core architectures

Loading...
Searching...
No Matches
gko::matrix::SparsityCsr< ValueType, IndexType > Class Template Reference
Linear Operators » SpMV employing different Matrix formats | Linear Operators

SparsityCsr is a matrix format which stores only the sparsity pattern of a sparse matrix by compressing each row of the matrix (compressed sparse row format). More...

`#include <ginkgo/core/matrix/sparsity_csr.hpp>`

Inheritance diagram for gko::matrix::SparsityCsr< ValueType, IndexType >:
[legend]
Collaboration diagram for gko::matrix::SparsityCsr< ValueType, IndexType >:
[legend]

## Public Types
using | value_type = ValueType
using | index_type = IndexType
using | transposed_type = SparsityCsr<IndexType, ValueType>
using | mat_data = matrix_data<ValueType, IndexType>
using | device_mat_data = device_matrix_data<ValueType, IndexType>
Public Types inherited from gko::EnablePolymorphicAssignment< SparsityCsr< default_precision, int32 > >
using | result_type
Public Types inherited from gko::ReadableFromMatrixData< default_precision, int32 >
using | value_type
using | index_type
Public Types inherited from gko::WritableToMatrixData< default_precision, int32 >
using | value_type
using | index_type

## Public Member Functions
void | convert_to (Csr< ValueType, IndexType > *result) const override
void | move_to (Csr< ValueType, IndexType > *result) override
void | convert_to (Dense< ValueType > *result) const override
void | move_to (Dense< ValueType > *result) override
void | read (const mat_data &data) override
void | read (const device_mat_data &data) override
void | read (device_mat_data &&data) override
void | write (mat_data &data) const override
std::unique_ptr< LinOp > | transpose () const override
| Returns a LinOp representing the transpose of the Transposable object.
std::unique_ptr< LinOp > | conj_transpose () const override
| Returns a LinOp representing the conjugate transpose of the Transposable object.
std::unique_ptr< SparsityCsr > | to_adjacency_matrix () const
| Transforms the sparsity matrix to an adjacency matrix.
void | sort_by_column_index ()
| Sorts each row by column index.
bool | is_sorted_by_column_index () const
index_type * | get_col_idxs () noexcept
| Returns the column indices of the matrix.
const index_type * | get_const_col_idxs () const noexcept
| Returns the column indices of the matrix.
index_type * | get_row_ptrs () noexcept
| Returns the row pointers of the matrix.
const index_type * | get_const_row_ptrs () const noexcept
| Returns the row pointers of the matrix.
value_type * | get_value () noexcept
| Returns the value stored in the matrix.
const value_type * | get_const_value () const noexcept
| Returns the value stored in the matrix.
size_type | get_num_nonzeros () const noexcept
| Returns the number of elements explicitly stored in the matrix.
SparsityCsr & | operator= (const SparsityCsr &)
| Copy-assigns a SparsityCsr matrix.
SparsityCsr & | operator= (SparsityCsr &&)
| Move-assigns a SparsityCsr matrix.
| SparsityCsr (const SparsityCsr &)
| Copy-constructs a SparsityCsr matrix.
| SparsityCsr (SparsityCsr &&)
| Move-constructs a SparsityCsr matrix.
Public Member Functions inherited from gko::EnableLinOp< SparsityCsr< default_precision, int32 > >
const SparsityCsr< default_precision, int32 > * | apply (ptr_param< const LinOp > b, ptr_param< LinOp > x) const
Public Member Functions inherited from gko::EnablePolymorphicAssignment< SparsityCsr< default_precision, int32 > >
void | convert_to (result_type *result) const override
void | move_to (result_type *result) override
Public Member Functions inherited from gko::ReadableFromMatrixData< default_precision, int32 >
virtual void | read (const matrix_data< default_precision, int32 > &data)=0
| Reads a matrix from a matrix_data structure.
Public Member Functions inherited from gko::WritableToMatrixData< default_precision, int32 >
virtual void | write (matrix_data< default_precision, int32 > &data) const=0
| Writes a matrix to a matrix_data structure.

## Static Public Member Functions
static std::unique_ptr< SparsityCsr > | create (std::shared_ptr< const Executor > exec, const dim< 2 > &size=dim< 2 >{}, size_type num_nonzeros={})
| Creates an uninitialized SparsityCsr matrix of the specified size.
static std::unique_ptr< SparsityCsr > | create (std::shared_ptr< const Executor > exec, const dim< 2 > &size, array< index_type > col_idxs, array< index_type > row_ptrs, value_type value=one< ValueType >())
| Creates a SparsityCsr matrix from already allocated (and initialized) row pointer and column index arrays.
template<typename ColIndexType, typename RowPtrType>
static std::unique_ptr< SparsityCsr > | create (std::shared_ptr< const Executor > exec, const dim< 2 > &size, std::initializer_list< ColIndexType > col_idxs, std::initializer_list< RowPtrType > row_ptrs, value_type value=one< ValueType >())
| create(std::shared_ptr<constExecutor>, const dim<2>&, array<index_type>, array<index_type>,value_type)
static std::unique_ptr< SparsityCsr > | create (std::shared_ptr< const Executor > exec, std::shared_ptr< const LinOp > matrix)
| Creates a Sparsity matrix from an existing matrix.
static std::unique_ptr< const SparsityCsr > | create_const (std::shared_ptr< const Executor > exec, const dim< 2 > &size, gko::detail::const_array_view< IndexType > &&col_idxs, gko::detail::const_array_view< IndexType > &&row_ptrs, ValueType value=one< ValueType >())
| Creates a constant (immutable) SparsityCsr matrix from constant arrays.

## Friends
class | EnablePolymorphicObject< SparsityCsr, LinOp >
class | Csr< ValueType, IndexType >
class | Dense< ValueType >
class | Fbcsr< ValueType, IndexType >

## Detailed Description

template<typename ValueType = default_precision, typename IndexType = int32>
class gko::matrix::SparsityCsr< ValueType, IndexType >

SparsityCsr is a matrix format which stores only the sparsity pattern of a sparse matrix by compressing each row of the matrix (compressed sparse row format).

The values of the nonzero elements are stored as a value array of length 1. All the values in the matrix are equal to this value. By default, this value is set to 1.0. A row pointer array also stores the linearized starting index of each row. An additional column index array is used to identify the column where a nonzero is present.

Template Parameters

  ValueType | precision of vectors in apply
  IndexType | precision of matrix indexes

## Constructor & Destructor Documentation

## ◆ SparsityCsr() [1/2]

template<typename ValueType = default_precision, typename IndexType = int32>

gko::matrix::SparsityCsr< ValueType, IndexType >::SparsityCsr | ( | const SparsityCsr< ValueType, IndexType > & |  | ) |

Copy-constructs a SparsityCsr matrix.

Inherits executor, strategy and data.

## ◆ SparsityCsr() [2/2]

template<typename ValueType = default_precision, typename IndexType = int32>

gko::matrix::SparsityCsr< ValueType, IndexType >::SparsityCsr | ( | SparsityCsr< ValueType, IndexType > && |  | ) |

Move-constructs a SparsityCsr matrix.

Inherits executor, moves the data and leaves the moved-from object in an empty state (0x0 LinOp with unchanged executor, no nonzeros and valid row pointers).

## Member Function Documentation

## ◆ conj_transpose()

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< LinOp > gko::matrix::SparsityCsr< ValueType, IndexType >::conj_transpose | ( |  | ) | const
| overridevirtual

Returns a LinOp representing the conjugate transpose of the Transposable object.

Returns
  a pointer to the new conjugate transposed object

Implements gko::Transposable.

## ◆ create() [1/4]

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< SparsityCsr > gko::matrix::SparsityCsr< ValueType, IndexType >::create | ( | std::shared_ptr< const Executor > | exec,
|  | const dim< 2 > & | size,
|  | array< index_type > | col_idxs,
|  | array< index_type > | row_ptrs,
|  | value_type | value = one< ValueType >() )
| static

Creates a SparsityCsr matrix from already allocated (and initialized) row pointer and column index arrays.

Template Parameters

  ColIdxsArray | type of col_idxs array
  RowPtrsArray | type of row_ptrs array

Parameters

  exec | Executor associated to the matrix
  size | size of the matrix
  col_idxs | array of column indexes
  row_ptrs | array of row pointers
  value | value stored. (same value for all matrix elements)

Note
  If one of row_ptrs or col_idxs is not an rvalue, not an array of IndexType and IndexType respectively, or is on the wrong executor, an internal copy of that array will be created, and the original array data will not be used in the matrix.

## ◆ create() [2/4]

template<typename ValueType = default_precision, typename IndexType = int32>
template<typename ColIndexType, typename RowPtrType>

std::unique_ptr< SparsityCsr > gko::matrix::SparsityCsr< ValueType, IndexType >::create | ( | std::shared_ptr< const Executor > | exec,
|  | const dim< 2 > & | size,
|  | std::initializer_list< ColIndexType > | col_idxs,
|  | std::initializer_list< RowPtrType > | row_ptrs,
|  | value_type | value = one<ValueType>() )
| inlinestatic

create(std::shared_ptr<constExecutor>, const dim<2>&, array<index_type>, array<index_type>,value_type)

create(std::shared_ptr<constExecutor>, const dim<2>&, array<index_type>, array<index_type>,value_type)

## ◆ create() [3/4]

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< SparsityCsr > gko::matrix::SparsityCsr< ValueType, IndexType >::create | ( | std::shared_ptr< const Executor > | exec,
|  | const dim< 2 > & | size = dim< 2 >{},
|  | size_type | num_nonzeros = {} )
| static

Creates an uninitialized SparsityCsr matrix of the specified size.

Parameters

  exec | Executor associated to the matrix
  size | size of the matrix
  num_nonzeros | number of nonzeros

Referenced by gko::matrix::SparsityCsr< value_type, index_type >::create().

## ◆ create() [4/4]

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< SparsityCsr > gko::matrix::SparsityCsr< ValueType, IndexType >::create | ( | std::shared_ptr< const Executor > | exec,
|  | std::shared_ptr< const LinOp > | matrix )
| static

Creates a Sparsity matrix from an existing matrix.

Uses the copy_and_convert_to functionality.

Parameters

  exec | Executor associated to the matrix
  matrix | The input matrix

## ◆ create_const()

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< const SparsityCsr > gko::matrix::SparsityCsr< ValueType, IndexType >::create_const | ( | std::shared_ptr< const Executor > | exec,
|  | const dim< 2 > & | size,
|  | gko::detail::const_array_view< IndexType > && | col_idxs,
|  | gko::detail::const_array_view< IndexType > && | row_ptrs,
|  | ValueType | value = one<ValueType>() )
| inlinestatic

Creates a constant (immutable) SparsityCsr matrix from constant arrays.

Parameters

  exec | the executor to create the matrix on
  size | the dimensions of the matrix
  values | the value array of the matrix
  col_idxs | the column index array of the matrix
  row_ptrs | the row pointer array of the matrix
  strategy | the strategy the matrix uses for SpMV operations

Returns
  A smart pointer to the constant matrix wrapping the input arrays (if they reside on the same executor as the matrix) or a copy of these arrays on the correct executor.

## ◆ get_col_idxs()

template<typename ValueType = default_precision, typename IndexType = int32>

index_type * gko::matrix::SparsityCsr< ValueType, IndexType >::get_col_idxs | ( |  | ) |
| inlinenoexcept

Returns the column indices of the matrix.

Returns
  the column indices of the matrix.

## ◆ get_const_col_idxs()

template<typename ValueType = default_precision, typename IndexType = int32>

const index_type * gko::matrix::SparsityCsr< ValueType, IndexType >::get_const_col_idxs | ( |  | ) | const
| inlinenoexcept

Returns the column indices of the matrix.

Returns
  the column indices of the matrix.

Note
  This is the constant version of the function, which can be significantly more memory efficient than the non-constant version, so always prefer this version.

## ◆ get_const_row_ptrs()

template<typename ValueType = default_precision, typename IndexType = int32>

const index_type * gko::matrix::SparsityCsr< ValueType, IndexType >::get_const_row_ptrs | ( |  | ) | const
| inlinenoexcept

Returns the row pointers of the matrix.

Returns
  the row pointers of the matrix.

Note
  This is the constant version of the function, which can be significantly more memory efficient than the non-constant version, so always prefer this version.

## ◆ get_const_value()

template<typename ValueType = default_precision, typename IndexType = int32>

const value_type * gko::matrix::SparsityCsr< ValueType, IndexType >::get_const_value | ( |  | ) | const
| inlinenoexcept

Returns the value stored in the matrix.

Returns
  the value of the matrix.

Note
  This is the constant version of the function, which can be significantly more memory efficient than the non-constant version, so always prefer this version.

## ◆ get_num_nonzeros()

template<typename ValueType = default_precision, typename IndexType = int32>

size_type gko::matrix::SparsityCsr< ValueType, IndexType >::get_num_nonzeros | ( |  | ) | const
| inlinenoexcept

Returns the number of elements explicitly stored in the matrix.

Returns
  the number of elements explicitly stored in the matrix

## ◆ get_row_ptrs()

template<typename ValueType = default_precision, typename IndexType = int32>

index_type * gko::matrix::SparsityCsr< ValueType, IndexType >::get_row_ptrs | ( |  | ) |
| inlinenoexcept

Returns the row pointers of the matrix.

Returns
  the row pointers of the matrix.

## ◆ get_value()

template<typename ValueType = default_precision, typename IndexType = int32>

value_type * gko::matrix::SparsityCsr< ValueType, IndexType >::get_value | ( |  | ) |
| inlinenoexcept

Returns the value stored in the matrix.

Returns
  the value of the matrix.

## ◆ operator=() [1/2]

template<typename ValueType = default_precision, typename IndexType = int32>

SparsityCsr & gko::matrix::SparsityCsr< ValueType, IndexType >::operator= | ( | const SparsityCsr< ValueType, IndexType > & |  | ) |

Copy-assigns a SparsityCsr matrix.

Preserves executor, copies everything else.

## ◆ operator=() [2/2]

template<typename ValueType = default_precision, typename IndexType = int32>

SparsityCsr & gko::matrix::SparsityCsr< ValueType, IndexType >::operator= | ( | SparsityCsr< ValueType, IndexType > && |  | ) |

Move-assigns a SparsityCsr matrix.

Preserves executor, moves the data and leaves the moved-from object in an empty state (0x0 LinOp with unchanged executor, no nonzeros and valid row pointers).

## ◆ to_adjacency_matrix()

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< SparsityCsr > gko::matrix::SparsityCsr< ValueType, IndexType >::to_adjacency_matrix | ( |  | ) | const

Transforms the sparsity matrix to an adjacency matrix.

As the adjacency matrix has to be square, the input SparsityCsr matrix for this function to work has to be square.

Note
  The adjacency matrix in this case is the sparsity pattern but with the diagonal ones removed. This is mainly used for the reordering/partitioning as taken in by graph libraries such as METIS.

## ◆ transpose()

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< LinOp > gko::matrix::SparsityCsr< ValueType, IndexType >::transpose | ( |  | ) | const
| overridevirtual

Returns a LinOp representing the transpose of the Transposable object.

Returns
  a pointer to the new transposed object

Implements gko::Transposable.

The documentation for this class was generated from the following files:

- ginkgo/core/matrix/csr.hpp
- ginkgo/core/matrix/sparsity_csr.hpp